/*
** timer.c: timers
*/

#define	__NP_TIMER_SELF

#include "sysinc.h"
#include "list.h"
#include "timer.h"


/*
** Init Timer table
**
** - the only function that allocates memory for the timer handling
*/

int timer_init(timetable_t *tp)
{
int i;

	tp->queue = (list_t *) malloc(tp->rows * sizeof(*tp->queue));
	if (!tp->queue) {
		return 0;
	}
	/* OK, now init this time table	*/
	tp->pos = 0;
	tp->entries = 0;
	/* Now init the timer queue	*/
	for (i = 0; i < tp->rows; i++) {
		list_init(&tp->queue[i]);
	}
	return 1;
}

/*
** Adjust the time table pointer
*/

void timer_adjust(timetable_t *tp, int offset)
{
	tp->pos = (tp->pos + offset) % tp->rows;
}

void timer_add(timetable_t *tp,list_t *l,int seconds)
{
	list_append(l,&tp->queue[(tp->pos+seconds)%tp->rows]);
	tp->entries ++;
}

void timer_del(timetable_t *tp,list_t *l)
{
	list_remove_init(l);
	tp->entries --;
}

void timer_mod(timetable_t *tp,list_t *l,int seconds)
{
	if (!list_empty(l)) {
		timer_del(tp,l);
	}
	if (seconds) {
		timer_add(tp,l,seconds);
	}
}

